\ COPYRIGHT by GPL 1993 DUTCH FORTH WORKSHOP - FILENAME : STRINGL.FRT #1 
\ LANGUAGE    : ANS Forth with environmental dependancies
\
\  PROJECT     : DFW Forth Environments
\  DESCRIPTION : manipulation with character strings / counted strings
\  CATEGORY    : utility
\  AUTHOR      : Albert van der Horst
\  LAST CHANGE : AH 940907 Use of @+
\

\ DOC
\   The idea of strings is that a character string (s)
\   is in fact a counted string (cs) that has been stored.
\   s (c-addr) is the string, cs (c-addr u) is constant string
\ ENDDOC

\ Look mother without PRIVATE parts!
\ HIDE $@   HIDE $!  HIDE $? HIDE $.   HIDE $+!   HIDE $+C!
\ Fetch a constant string c from s
: $@     ( s -- cs )
\   DUP CELL+ SWAP @
  @+
;

\ Store a constant string cs into s
: $!    ( cs s -- )
  2DUP ! CELL+ SWAP CMOVE
;

\ Append a constant string cs to s
: $+! ( cs s -- )
   DUP @ >R    ( remember old count )
   2DUP +!
   CELL+   R> CHARS +   SWAP CMOVE

 ;

\ Append a character char to s
: $+C! ( char s -- )
  DUP >R
  DUP @ CHARS + CELL+ C!
  1 R> +!
;

: $. TYPE ;
: $? $@ TYPE ;

CREATE PADPAD 100 ALLOT
S" AAP" PADPAD $!
CR .( EXPECT |AAP| : |) PADPAD $? CHAR | EMIT
S" FRED" PADPAD $+!
CR .( EXPECT |AAPFRED| : |) PADPAD $? CHAR | EMIT
CHAR Q PADPAD $+C!
CR .( EXPECT |AAPFREDQ| : |) PADPAD $? CHAR | EMIT
FORGET PADPAD
\ SECURE @  SECURE OFF

\ Inplaats van een foutlmelding een nulstring geven in GET$

\ : GET$      ( s -- cs )                  \ Catch a quoted string
\     DUP 1+ C@ &" <>
\     IF  0  EXIT  THEN                   \ Leave zero length <c>
\     >R  R@ $@ 1 /STRING  R@ $!          \ Cut leading quote
\     R@ $@ 0
\     ?DO     DUP I + C@ &" <>            \ Quote found ?
\     WHILE
\     LOOP
\     DROP R> 0  EXIT                     \ Leave zero length <c>
\     THEN
\     DROP  I  UNLOOP
\     R> 1+ SWAP                          \ Leave string without quotes
\     ;
\
\ : CUT-QUOTES    ( s -- )                \ Remove quotes from a string
\     DUP $@  2DUP BOUNDS
\     ?DO     I C@ &" <>
\     WHILE   1 /STRING
\     LOOP
\             DROP 0
\     ELSE
\             UNLOOP  1 /STRING
\     THEN
\     ROT $!
\     ;

\ Liever
\ : CUT-QUOTES
\     [CHAR] " SPLIT NIP
\     [CHAR] " SPLIT DROP
\ ;

\ of
\   2 - SWAP 1 CHARS + SWAP

\ : ADD$SPECIALS  ( s-dest s-from -- )    \ Add backspace or carriage return to string
\     $@ BOUNDS
\     ?DO     I C@
\             CASE
\                 &B OF  BS OVER $+C!  ENDOF
\                 &R OF  ^M OVER $+C!  ENDOF
\             ENDCASE
\     LOOP
\     DROP
\     ;
\
\ SECURE !
